## flameshot 12.1.0%2Bds

=== external/Qt-Color-Widgets/CMakeLists.txt ===
#
# Copyright (C) 2013-2020 Mattia Basaglia
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
cmake_minimum_required (VERSION 3.1 FATAL_ERROR)
if ( ${CMAKE_VERSION} VERSION_GREATER "3.12.0")
    cmake_policy(SET CMP0077 NEW)
endif()

set(COLORWIDGET_PROJECT_NAME QtColorWidgets)
project(${COLORWIDGET_PROJECT_NAME} CXX)


set (CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules
  ${CMAKE_CURRENT_LIST_DIR})


include (CheckCXXCompilerFlag)

include (cmake/install.cmake)
include (cmake/versioning.cmake)


SET (${COLORWIDGET_PROJECT_NAME}_VERSION_MAJOR 2)
SET (${COLORWIDGET_PROJECT_NAME}_VERSION_MINOR 2)
SET (${COLORWIDGET_PROJECT_NAME}_VERSION_PATCH 0)
SET (${COLORWIDGET_PROJECT_NAME}_VERSION "${${COLORWIDGET_PROJECT_NAME}_VERSION_MAJOR}.${${COLORWIDGET_PROJECT_NAME}_VERSION_MINOR}.${${COLORWIDGET_PROJECT_NAME}_VERSION_PATCH}")




set(QT_VERSION_MAJOR 5)
find_package(QT NAMES Qt5 Qt4 COMPONENTS Core QUIET)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core Widgets REQUIRED)


# Auto generate moc files
set(CMAKE_AUTOMOC ON)
# Auto generate moc files
set(CMAKE_AUTOUIC ON)
# Auto generate moc files
set(CMAKE_AUTORCC ON)


set (TARGET_NAME ${COLORWIDGET_PROJECT_NAME})
option(COLOR_WIDGETS_QT_SUFFIX "Append qt version to the target output files" OFF)
if ( COLOR_WIDGETS_QT_SUFFIX )
    set (TARGET_OUTPUT_SUFFIX "-Qt${QT_VERSION}${${COLORWIDGET_PROJECT_NAME}_VERSION_MAJOR}")
else()
    set (TARGET_OUTPUT_SUFFIX "")
endif()

set (INCLUDE_PREFIX "QtColorWidgets")
set (COLOR_WIDGETS_LIBRARY "${TARGET_NAME}")

add_definitions(-DQTCOLORWIDGETS_STATICALLY_LINKED)


add_library (${TARGET_NAME} STATIC "")
set_target_properties(${TARGET_NAME}
  PROPERTIES
  EXPORT_NAME "${TARGET_NAME}${TARGET_OUTPUT_SUFFIX}")


set_target_properties (${TARGET_NAME}
  PROPERTIES
  CXX_STANDARD 11
  CXX_STANDARD_REQUIRED ON
  VERSION ${${COLORWIDGET_PROJECT_NAME}_VERSION}
  SOVERSION ${${COLORWIDGET_PROJECT_NAME}_VERSION_MAJOR}
  "INTERFACE_${COLORWIDGET_PROJECT_NAME}_MAJOR_VERSION" ${${COLORWIDGET_PROJECT_NAME}_VERSION_MAJOR}
  COMPATIBLE_INTERFACE_STRING "${COLORWIDGET_PROJECT_NAME}_MAJOR_VERSION"
  COMPILE_DEFINITIONS QTCOLORWIDGETS_LIBRARY
  OUTPUT_NAME "${TARGET_NAME}${TARGET_OUTPUT_SUFFIX}")

check_cxx_compiler_flag ("-Wall" Wall_FLAG_SUPPORTED)

if (Wall_FLAG_SUPPORTED)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall")
endif (Wall_FLAG_SUPPORTED)

check_cxx_compiler_flag ("-pedantic" pedantic_FLAG_SUPPORTED)

if (pedantic_FLAG_SUPPORTED)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -pedantic")
endif (pedantic_FLAG_SUPPORTED)

check_cxx_compiler_flag ("-Wextra" Wextra_FLAG_SUPPORTED)

if (Wextra_FLAG_SUPPORTED)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wextra")
endif (Wextra_FLAG_SUPPORTED)


set (EXPORT_HEADER "${INCLUDE_PREFIX}/colorwidgets_global.hpp")


generate_versioning_information (
    TARGET_NAME ${TARGET_NAME}
    EXPORT_HEADER ${EXPORT_HEADER}
    EXPORT_MACRO QCP_EXPORT
    VERSIONED_ENTITY ${COLORWIDGET_PROJECT_NAME}
    INCLUDE_PREFIX ${INCLUDE_PREFIX}
    COMPANY_NAME "Mattia Basaglia"
    COMPANY_COPYRIGHT "Mattia Basaglia Copyright (C) 2013-2020"
    FILE_DESCRIPTION "Color wheel widget and dialog for Qt${QT_VERSION}"
)


target_include_directories(${TARGET_NAME}
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
  PUBLIC
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
  $<INSTALL_INTERFACE:include>
  )


add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/include/${INCLUDE_PREFIX})
add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/resources/${INCLUDE_PREFIX})
add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/src/${INCLUDE_PREFIX})


target_link_libraries (${TARGET_NAME} PRIVATE Qt${QT_VERSION_MAJOR}::Widgets)


install_project (
  PROJECT_NAME ${COLORWIDGET_PROJECT_NAME}
  TARGET_NAME ${TARGET_NAME}
  TARGET_OUTPUT_SUFFIX "${TARGET_OUTPUT_SUFFIX}"
  EXPORT_HEADER ${EXPORT_HEADER}
  INCLUDE_PREFIX ${INCLUDE_PREFIX}
  HEADER_MATCHING_REGEX "^.*\.h$|^.*\.hpp$|^.*$"
  VERSION_HEADER ${CMAKE_CURRENT_BINARY_DIR}/${COLORWIDGET_PROJECT_NAME}_version.h
  NAMESPACE "")


add_subdirectory (gallery)

option(QTCOLORWIDGETS_DESIGNER_PLUGIN "Build QtDesigner plugin" ON)
if (${QTCOLORWIDGETS_DESIGNER_PLUGIN})
    find_package (Qt5Designer QUIET)
    if (Qt5Designer_FOUND)
        add_subdirectory (color_widgets_designer_plugin)
    endif(Qt5Designer_FOUND)
endif()

configure_file(Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
add_custom_target(
    ${COLORWIDGET_PROJECT_NAME}_docs
    COMMAND doxygen Doxyfile
    COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/gallery/*.png ${CMAKE_CURRENT_BINARY_DIR}/doxygen/html
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

=== src/cli/CMakeLists.txt ===
target_sources(flameshot PRIVATE commandlineparser.cpp commandoption.cpp commandargument.cpp)

## flameshot 12.1.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
# cmake_policy(SET CMP0076 OLD)

set(FLAMESHOT_VERSION 12.1.0)

# Flameshot-org
set(GIT_API_URL "https://api.github.com/repos/flameshot-org/flameshot/releases/latest")
# Namecheap
# set(GIT_API_URL "https://api.github.com/repos/namecheap/flameshot/releases/latest")

# TODO - fix it for all linux distros
#find_package (Git)
#if (GIT_FOUND)
#  message("git found: ${GIT_EXECUTABLE} in version     ${GIT_VERSION_STRING}")
#
#  # set flameshot updates url
#  execute_process(COMMAND ${GIT_EXECUTABLE} ls-remote --get-url OUTPUT_VARIABLE GIT_ORIGIN_REMOTE)
#  message("GIT_ORIGIN_REMOTE: ${GIT_ORIGIN_REMOTE}")
#  string(REGEX REPLACE ".git\r*\n*$" "/releases/latest" GIT_API_URL ${GIT_ORIGIN_REMOTE})
#  string(REGEX REPLACE "^.*:" "https://api.github.com/repos/" GIT_API_URL ${GIT_API_URL})
#  message("GIT_API_URL: '${GIT_API_URL}'")
#
#  # get application version
#  execute_process(COMMAND ${GIT_EXECUTABLE} describe --tags --abbrev=0 --match v[0-9]* OUTPUT_VARIABLE FLAMESHOT_VERSION)
#  string(REGEX REPLACE "\r" "" FLAMESHOT_VERSION ${FLAMESHOT_VERSION})
#  string(REGEX REPLACE "\n" "" FLAMESHOT_VERSION ${FLAMESHOT_VERSION})
#  string(REGEX REPLACE "^v" "" FLAMESHOT_VERSION ${FLAMESHOT_VERSION})
#  message("FLAMESHOT_VERSION: '${FLAMESHOT_VERSION}'")
#else()
#  message("git command is not found")
#endif ()

project(
        flameshot
        VERSION ${FLAMESHOT_VERSION}
        LANGUAGES CXX)
set(PROJECT_NAME_CAPITALIZED "Flameshot")

# This can be read from ${PROJECT_NAME} after project() is called
if (APPLE)
  set(CMAKE_OSX_DEPLOYMENT_TARGET "10.15" CACHE STRING "Minimum OS X deployment version")
endif()


# Configuration options
set(DEFAULT_RUN_IN_PLACE FALSE)
if(WIN32)
  set(DEFAULT_RUN_IN_PLACE TRUE)
  # For Windows RC file.
  add_definitions(-DFLAMESHOT_VERSION_MAJOR=${CMAKE_PROJECT_VERSION_MAJOR})
  add_definitions(-DFLAMESHOT_VERSION_MINOR=${CMAKE_PROJECT_VERSION_MINOR})
  add_definitions(-DFLAMESHOT_VERSION_BUGFIX=${CMAKE_PROJECT_VERSION_PATCH})
  add_definitions(-DFLAMESHOT_VERSION_BUILD=1)
  add_definitions(-DFLAMESHOT_VERSION_STRING="${PROJECT_VERSION}")
elseif(APPLE)
  set(Qt5_DIR "$(brew --prefix qt5)/lib/cmake/Qt5/" CACHE PATH "directory where Qt5Config.cmake exists.")
  set(CMAKE_MACOSX_BUNDLE ON)
  set(CMAKE_MACOSX_RPATH ON)
endif()
set(RUN_IN_PLACE
        ${DEFAULT_RUN_IN_PLACE}
        CACHE BOOL "Run directly in source directory structure")


option(FLAMESHOT_DEBUG_CAPTURE "Enable mode to make debugging easier" OFF)
option(USE_MONOCHROME_ICON "Build using monochrome icon as default" OFF)
option(GENERATE_TS "Regenerate translation source files" OFF)
option(USE_EXTERNAL_SINGLEAPPLICATION "Use external QtSingleApplication library" OFF)
option(USE_LAUNCHER_ABSOLUTE_PATH "Use absolute path for the desktop launcher" ON)
option(USE_WAYLAND_CLIPBOARD "USE KF Gui Wayland Clipboard" OFF)

include(cmake/StandardProjectSettings.cmake)

add_library(project_options INTERFACE)
target_compile_features(project_options INTERFACE cxx_std_17)

add_library(project_warnings INTERFACE)

# enable cache system
include(cmake/Cache.cmake)

# standard compiler warnings
include(cmake/CompilerWarnings.cmake)
# set_project_warnings(project_warnings)

# sanitizer options if supported by compiler
include(cmake/Sanitizers.cmake)
enable_sanitizers(project_options)

# allow for static analysis options include(cmake/StaticAnalyzers.cmake)

set(QAPPLICATION_CLASS
        QApplication
        CACHE STRING "Inheritance class for SingleApplication")

if(USE_EXTERNAL_SINGLEAPPLICATION)
  # look for external QtSingleApplication
  # package dev-qt/qtsingleapplication provides no symlink to current version
  set(qtsingleapplication_libs libQt5Solutions_SingleApplication-2.6 Qt5Solutions_SingleApplication-2.6)
  find_library(QTSINGLEAPPLICATION_LIBRARY NAMES ${qtsingleapplication_libs})
  message(STATUS "Using external SingleApplication library")
else()
  add_subdirectory(external/singleapplication)
  set(QTSINGLEAPPLICATION_LIBRARY SingleApplication::SingleApplication)
endif()


option(BUILD_STATIC_LIBS ON)
option(BUILD_SHARED_LIBS OFF)
add_subdirectory(external/Qt-Color-Widgets EXCLUDE_FROM_ALL) 


if (APPLE)
  add_subdirectory(external/QHotkey)
endif()
add_subdirectory(src)

# CPack
set(CPACK_PACKAGE_VENDOR "flameshot-org")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Powerful yet simple to use screenshot software.")
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_PACKAGE_HOMEPAGE_URL "https://flameshot.org")
set(CPACK_PACKAGE_CONTACT "flameshot-org developers <info@flameshot.org>")
set(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}/data/img/app/org.flameshot.Flameshot.svg") # TODO: Can any generator make
# use of this?
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README.md") # TODO: Where is this used? Do we need a better
# source?

if(WIN32)
  # Include all dynamically linked runtime libraries such as MSVCRxxx.dll
  include(InstallRequiredSystemLibraries)

  if(RUN_IN_PLACE)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
      set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}-win64")
    else()
      set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}-win32")
    endif()

    set(CPACK_GENERATOR ZIP)

  else()
    set(CPACK_GENERATOR WIX ZIP)
    set(CPACK_PACKAGE_NAME "${PROJECT_NAME_CAPITALIZED}")
    set(CPACK_PACKAGE_INSTALL_DIRECTORY "${PROJECT_NAME_CAPITALIZED}")
    set(CPACK_PACKAGE_EXECUTABLES ${PROJECT_NAME} "${PROJECT_NAME_CAPITALIZED}")
    set(CPACK_CREATE_DESKTOP_LINKS ${PROJECT_NAME})

    # WIX (Windows .msi installer)
    # 48x48 pixels
    set(CPACK_WIX_PRODUCT_ICON "${CMAKE_SOURCE_DIR}/data/img/app/flameshot.ico")
    # Supported languages can be found at http://wixtoolset.org/documentation/manual/v3/wixui/wixui_localization.html
    # set(CPACK_WIX_CULTURES "ar-SA,bg-BG,ca-ES,hr-HR,cs-CZ,da-DK,nl-NL,en-US,et-EE,fi-FI,fr-FR,de-DE")
    set(CPACK_WIX_UI_BANNER "${CMAKE_SOURCE_DIR}/packaging/win-installer/Bitmaps/CPACK_WIX_UI_BANNER.BMP")
    set(CPACK_WIX_UI_DIALOG "${CMAKE_SOURCE_DIR}/packaging/win-installer/Bitmaps/CPACK_WIX_UI_DIALOG.BMP")
    set(CPACK_WIX_PROPERTY_ARPHELPLINK "${CPACK_PACKAGE_HOMEPAGE_URL}")
    set(CPACK_WIX_PROPERTY_ARPURLINFOABOUT "${CPACK_PACKAGE_HOMEPAGE_URL}")
    set(CPACK_WIX_ROOT_FEATURE_DESCRIPTION "${CPACK_PACKAGE_DESCRIPTION_SUMMARY}")
    set(CPACK_WIX_LIGHT_EXTRA_FLAGS "-dcl:high") # set high compression

    set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/packaging/win-installer/LICENSE/GPL-3.0.txt")
    set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README.md")

    # The correct way would be to include both x32 and x64 into one installer and install the appropriate one. CMake
    # does not support that, so there are two separate GUID's
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
      set(CPACK_WIX_UPGRADE_GUID "26D8062A-66D9-48D9-8924-42090FB9B3F9")
    else()
      set(CPACK_WIX_UPGRADE_GUID "2C53E1B9-51D9-4429-AAE4-B02221959AA5")
    endif()
  endif()
elseif(APPLE)
  set(CPACK_INCLUDE_TOPLEVEL_DIRECTORY 0)
  set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}-osx")
  set(CPACK_GENERATOR ZIP)
else()
  set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}-linux")
  set(CPACK_GENERATOR TGZ)
  set(CPACK_SOURCE_GENERATOR TGZ)
endif()

include(CPack)

=== src/tools/CMakeLists.txt ===
target_sources(flameshot PRIVATE arrow/arrowtool.h arrow/arrowtool.cpp)
target_sources(flameshot PRIVATE pixelate/pixelatetool.h pixelate/pixelatetool.cpp)
target_sources(flameshot PRIVATE circle/circletool.h circle/circletool.cpp)
target_sources(flameshot PRIVATE circlecount/circlecounttool.h circlecount/circlecounttool.cpp)
target_sources(flameshot PRIVATE copy/copytool.h copy/copytool.cpp)
target_sources(flameshot PRIVATE exit/exittool.h exit/exittool.cpp)
target_sources(flameshot PRIVATE sizeincrease/sizeincreasetool.h sizeincrease/sizeincreasetool.cpp)
target_sources(flameshot PRIVATE sizedecrease/sizedecreasetool.h sizedecrease/sizedecreasetool.cpp)
target_sources(
  flameshot
        PRIVATE imgupload/storages/imgur/imguruploader.h
        imgupload/storages/imgur/imguruploader.cpp
        imgupload/storages/imguploaderbase.h
        imgupload/storages/imguploaderbase.cpp
        imgupload/imguploadertool.h
        imgupload/imguploadertool.cpp
        imgupload/imguploadermanager.h
        imgupload/imguploadermanager.cpp
)
target_sources(
  flameshot
  PRIVATE launcher/applaunchertool.h
          launcher/applauncherwidget.h
          launcher/launcheritemdelegate.h
          launcher/terminallauncher.h
          launcher/applaunchertool.cpp
          launcher/applauncherwidget.cpp
          launcher/launcheritemdelegate.cpp
          launcher/openwithprogram.cpp
          launcher/terminallauncher.cpp)
target_sources(flameshot PRIVATE line/linetool.h line/linetool.cpp)
target_sources(flameshot PRIVATE marker/markertool.h marker/markertool.cpp)
target_sources(flameshot PRIVATE move/movetool.h move/movetool.cpp)
target_sources(flameshot PRIVATE pencil/penciltool.h pencil/penciltool.cpp)
target_sources(
  flameshot
  PRIVATE pin/pintool.h
          pin/pinwidget.h
          pin/pintool.cpp
          pin/pinwidget.cpp)
target_sources(flameshot PRIVATE rectangle/rectangletool.h rectangle/rectangletool.cpp)
target_sources(flameshot PRIVATE redo/redotool.h redo/redotool.cpp)
target_sources(flameshot PRIVATE save/savetool.h save/savetool.cpp)
target_sources(flameshot PRIVATE accept/accepttool.h accept/accepttool.cpp)
target_sources(flameshot PRIVATE invert/inverttool.h invert/inverttool.cpp)
target_sources(flameshot PRIVATE selection/selectiontool.h selection/selectiontool.cpp)
target_sources(flameshot PRIVATE sizeindicator/sizeindicatortool.h sizeindicator/sizeindicatortool.cpp)
target_sources(
  flameshot
  PRIVATE text/textconfig.h
          text/texttool.h
          text/textwidget.h
          text/textconfig.cpp
          text/texttool.cpp
          text/textwidget.cpp)
target_sources(flameshot PRIVATE undo/undotool.h undo/undotool.cpp)

target_sources(
  flameshot
  PRIVATE abstractactiontool.cpp
          abstractpathtool.cpp
          abstracttwopointtool.cpp
          capturecontext.cpp
          toolfactory.cpp
          abstractactiontool.h
          abstractpathtool.h
          abstracttwopointtool.h
          capturetool.h
          toolfactory.h)

=== src/widgets/capture/CMakeLists.txt ===
# Required to generate MOC
target_sources(
        flameshot
        PRIVATE buttonhandler.h
        capturebutton.h
        capturetoolbutton.h
        capturewidget.h
        colorpicker.h
        hovereventfilter.h
        overlaymessage.h
        selectionwidget.h
        magnifierwidget.h
        notifierbox.h
        modificationcommand.h)

target_sources(
        flameshot
        PRIVATE buttonhandler.cpp
        capturebutton.cpp
        capturetoolbutton.cpp
        capturewidget.cpp
        colorpicker.cpp
        hovereventfilter.cpp
        overlaymessage.cpp
        notifierbox.cpp
        selectionwidget.cpp
        magnifierwidget.cpp
        modificationcommand.cpp)

=== external/Qt-Color-Widgets/include/QtColorWidgets/CMakeLists.txt ===
set (HEADERS
abstract_widget_list.hpp
bound_color_selector.hpp
color_2d_slider.hpp
color_delegate.hpp
color_dialog.hpp
color_line_edit.hpp
color_list_widget.hpp
color_names.hpp
color_palette.hpp
color_palette_model.hpp
color_palette_widget.hpp
color_preview.hpp
color_selector.hpp
color_wheel.hpp
colorwidgets_global.hpp
gradient_slider.hpp
hue_slider.hpp
swatch.hpp
gradient_editor.hpp
harmony_color_wheel.hpp
gradient_list_model.hpp
gradient_delegate.hpp
)

file(RELATIVE_PATH
  PREFIX
  ${PROJECT_SOURCE_DIR}
  ${CMAKE_CURRENT_LIST_DIR})


foreach (HEADER IN LISTS HEADERS)
  target_sources (${TARGET_NAME}
    PRIVATE
    $<INSTALL_INTERFACE:${PREFIX}/${HEADER}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/${HEADER}>)
endforeach (HEADER IN HEADERS)

=== external/Qt-Color-Widgets/resources/QtColorWidgets/CMakeLists.txt ===
set (SOURCES
  alphaback.png
  color_widgets.qrc
  )

file(RELATIVE_PATH
  PREFIX
  ${PROJECT_SOURCE_DIR}
  ${CMAKE_CURRENT_LIST_DIR})


foreach (SOURCE IN LISTS SOURCES)
  target_sources (${TARGET_NAME}
    PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/${SOURCE}>)
endforeach (SOURCE IN SOURCES)

=== external/singleapplication/examples/calculator/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7.0)

project(calculator LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)

# SingleApplication base class
set(QAPPLICATION_CLASS QApplication)

add_executable(${PROJECT_NAME}
    button.h
    calculator.h
    button.cpp
    calculator.cpp
    main.cpp
)

find_package(Qt5 COMPONENTS Widgets REQUIRED)
add_subdirectory(../.. SingleApplication)
target_link_libraries(${PROJECT_NAME} SingleApplication::SingleApplication)

=== debian/changelog ===
flameshot (12.1.0+ds-3) unstable; urgency=medium

  * debian/control:
      - Bumped Standards-Version to 4.7.2.
      - Remove redundant 'Rules-Requires-Root: no'.
  * debian/rules: set CMAKE_POLICY_VERSION_MINIMUM to 3.5 to avoid build failure
    on CMake 4 after it removed backwards compatibility with earlier versions.
    (Closes: #1112915)
  * debian/watch: converted to version 5.

 -- David da Silva Polverari <polverari@debian.org>  Sat, 27 Sep 2025 05:01:22 +0000

flameshot (12.1.0+ds-2) unstable; urgency=medium

  * debian/control: removed libsingleapplication-dev from Build-Depends, as it
    was not used anyway -- the vendored version in the tarball is used instead.
    Moreover, repacking it to use the packaged version is not worthwhile at this
    moment, since upstream has switched to a non-free license (see #1050520),
    making future Debian releases unlikely.
  * debian/copyright: updated packaging copyright years.

 -- David da Silva Polverari <polverari@debian.org>  Tue, 18 Feb 2025 04:16:01 +0000

flameshot (12.1.0+ds-1) unstable; urgency=medium

  * New maintainer. (Closes: #1065588)
  * debian/control: bumped Standards-Version to 4.7.0.
  * debian/copyright:
      - Added Files paragraphs for previously not included patterns.
      - Added stand-alone License paragraphs for Commercial, BSD-3-Clause and
        BSD-2-Clause licenses.
      - Coalesced Files patterns with the same license under src/*.
      - Fixed upstream copyright attribution.
      - Replaced stand-alone License paragraph texts with standard text for
        licenses with dh_make templates available.
      - Simplified existing Files patterns.
      - Sorted existing Files paragraphs in alphabetical order.
      - Updated packaging copyright information.
      - Updated upstream copyright information.
  * debian/gbp.conf: created to comply with DEP-14 proposed repository layout.
  * debian/lintian-overrides: created to override lintian about spelling error
    in upstream license text.
  * debian/patches/:
      - Shortened all patch filenames.
      - 020_*.patch: tagged as Debian specific.
  * debian/rules:
      - Removed comments and unused export from dh_make default template.
      - Removed undeclared NULL variable used as recipe multi-line end marker.
  * debian/source/lintian-overrides: created to override false-positive lintians
    about long line in source file and not installing examples from the package.
  * debian/watch: added repacksuffix=+ds to options.

 -- David da Silva Polverari <polverari@debian.org>  Wed, 23 Oct 2024 02:12:13 +0000

flameshot (12.1.0-3) unstable; urgency=medium

  * QA upload.
  * Orphan the package. (See #1065588)

 -- Boyuan Yang <byang@debian.org>  Wed, 06 Mar 2024 22:13:13 -0500

=== debian/control ===
Source: flameshot
Section: graphics
Priority: optional
Maintainer: David da Silva Polverari <polverari@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libqt5svg5-dev,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
Standards-Version: 4.7.2
Homepage: https://flameshot.org
Vcs-Browser: https://salsa.debian.org/debian/flameshot
Vcs-Git: https://salsa.debian.org/debian/flameshot.git

Package: flameshot
Architecture: any
Depends:
 hicolor-icon-theme,
 libqt5svg5,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 xdg-desktop-portal-gtk | xdg-desktop-portal-gnome | xdg-desktop-portal-kde | xdg-desktop-portal-wlr,
 grim,
Suggests:
 ca-certificates,
 openssl,
Description: Powerful yet simple-to-use screenshot software
 Flameshot is a powerful yet simple-to-use screenshot software.
 Notable features include customizable appearance, in-app screenshot editing,
 D-Bus interface, experimental GNOME/KDE Wayland support, integration with
 Imgur and support for both GUI and CLI interface.

=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export QT_SELECT := 5

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	        -DFLAMESHOT_ABOUT_DEB_VERSION=$(DEB_VERSION) \
		-DUSE_LAUNCHER_ABSOLUTE_PATH:BOOL=OFF \
		-DCMAKE_POLICY_VERSION_MINIMUM=3.5

=== debian/watch ===
Version: 5
Dversion-Mangle: auto
Filename-Mangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%flameshot-$1.tar.gz%
Repacksuffix: +ds
Uversion-Mangle: s/.rc/~rc/
Source: https://github.com/flameshot-org/flameshot/tags
Matching-Pattern: (?:.*?/)?v?(\d[\d.]*r?c?\d?)\.tar\.gz

## flameshot 13.3.0

=== debian/changelog ===
flameshot (13.3.0-1~mx25+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 05 Dec 2025 20:16:54 -0800

flameshot (13.3.0-1) unstable; urgency=medium

  * QA upload.
  * New upstream release. (Closes: #1119145)
  * debian/patches/: Dropped, not needed.
  * debian/control: Update to use Qt6 build.
  * debian/rules: Update to use Qt6 build.

 -- Boyuan Yang <byang@debian.org>  Wed, 26 Nov 2025 21:57:57 -0500

flameshot (12.1.0+ds-4) unstable; urgency=medium

  * QA upload.
  * Set Debian QA Group as maintainer.

 -- David da Silva Polverari <polverari@debian.org>  Wed, 29 Oct 2025 18:11:44 +0000

=== debian/control ===
Source: flameshot
Section: graphics
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libkdsingleapplication-qt6-dev,
               libkf6guiaddons-dev,
               libqt-color-widgets-dev (>= 3.0.0-2~),
               qt6-base-dev (>= 6.2),
               qt6-l10n-tools,
               qt6-svg-dev (>= 6.2),
               qt6-tools-dev (>= 6.2),
               qt6-tools-dev-tools (>= 6.2)
Standards-Version: 4.7.2
Homepage: https://flameshot.org
Vcs-Browser: https://salsa.debian.org/debian/flameshot
Vcs-Git: https://salsa.debian.org/debian/flameshot.git

Package: flameshot
Architecture: any
Depends: hicolor-icon-theme, libqt6svg6, ${misc:Depends}, ${shlibs:Depends}
Recommends: grim,
            xdg-desktop-portal-gtk | xdg-desktop-portal-gnome | xdg-desktop-portal-kde | xdg-desktop-portal-wlr
Suggests: ca-certificates, openssl, qt6-image-formats-plugins
Description: Powerful yet simple-to-use screenshot software
 Flameshot is a powerful yet simple-to-use screenshot software.
 Notable features include customizable appearance, in-app screenshot editing,
 D-Bus interface, experimental GNOME/KDE Wayland support, integration with
 Imgur and support for both GUI and CLI interface.

=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# For version string in About dialog
export GIT_HASH = Debian-$(DEB_VERSION)

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DUSE_LAUNCHER_ABSOLUTE_PATH:BOOL=OFF \
		-DDISABLE_UPDATE_CHECKER:BOOL=ON \
		-DUSE_WAYLAND_CLIPBOARD:BOOL=ON \
		-DUSE_BUNDLED_KDSINGLEAPPLICATION:BOOL=OFF

# No dbgsym packages:
override_dh_strip:
	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym

## flameshot 13.3.0+git20251204

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,43 +1,53 @@
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.22)
 # cmake_policy(SET CMP0076 OLD)
 
-set(FLAMESHOT_VERSION 12.1.0)
+set(FLAMESHOT_VERSION 13.3.0)
 
 # Flameshot-org
 set(GIT_API_URL "https://api.github.com/repos/flameshot-org/flameshot/releases/latest")
-# Namecheap
-# set(GIT_API_URL "https://api.github.com/repos/namecheap/flameshot/releases/latest")
-
-# TODO - fix it for all linux distros
-#find_package (Git)
-#if (GIT_FOUND)
-#  message("git found: ${GIT_EXECUTABLE} in version     ${GIT_VERSION_STRING}")
-#
-#  # set flameshot updates url
-#  execute_process(COMMAND ${GIT_EXECUTABLE} ls-remote --get-url OUTPUT_VARIABLE GIT_ORIGIN_REMOTE)
-#  message("GIT_ORIGIN_REMOTE: ${GIT_ORIGIN_REMOTE}")
-#  string(REGEX REPLACE ".git\r*\n*$" "/releases/latest" GIT_API_URL ${GIT_ORIGIN_REMOTE})
-#  string(REGEX REPLACE "^.*:" "https://api.github.com/repos/" GIT_API_URL ${GIT_API_URL})
-#  message("GIT_API_URL: '${GIT_API_URL}'")
-#
-#  # get application version
-#  execute_process(COMMAND ${GIT_EXECUTABLE} describe --tags --abbrev=0 --match v[0-9]* OUTPUT_VARIABLE FLAMESHOT_VERSION)
-#  string(REGEX REPLACE "\r" "" FLAMESHOT_VERSION ${FLAMESHOT_VERSION})
-#  string(REGEX REPLACE "\n" "" FLAMESHOT_VERSION ${FLAMESHOT_VERSION})
-#  string(REGEX REPLACE "^v" "" FLAMESHOT_VERSION ${FLAMESHOT_VERSION})
-#  message("FLAMESHOT_VERSION: '${FLAMESHOT_VERSION}'")
-#else()
-#  message("git command is not found")
-#endif ()
 
 project(
-        flameshot
-        VERSION ${FLAMESHOT_VERSION}
-        LANGUAGES CXX)
+  flameshot
+  VERSION ${FLAMESHOT_VERSION}
+  LANGUAGES CXX)
 set(PROJECT_NAME_CAPITALIZED "Flameshot")
 
+include(FetchContent)
+#Must be set before fetching external content!
+#QT_DEFAULT_MAJOR_VERSION used by QHotkey
+set(QT_DEFAULT_MAJOR_VERSION 6 CACHE STRING "")
+#QT_VERSION_MAJOR used by Flameshot and QtColorWidgets
+set(QT_VERSION_MAJOR 6 CACHE STRING "")
+#BUILD_SHARED_LIBS used by QHotkey and QtColorWidgets
+option(BUILD_SHARED_LIBS OFF)
+
+#Needed due to linker error with QtColorWidget
+set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+
+
+# Dependency can be fetched via flatpak builder
+if(EXISTS "${CMAKE_SOURCE_DIR}/external/Qt-Color-Widgets/CMakeLists.txt")
+  add_subdirectory("${CMAKE_SOURCE_DIR}/external/Qt-Color-Widgets" EXCLUDE_FROM_ALL)
+else()
+  FetchContent_Declare(
+    qtColorWidgets
+    GIT_REPOSITORY https://gitlab.com/mattbas/Qt-Color-Widgets.git
+    GIT_TAG 352bc8f99bf2174d5724ee70623427aa31ddc26a
+  )
+  #Workaround for duplicate GUID in windows WIX installer
+  if(WIN32)
+    FetchContent_GetProperties(qtColorWidgets)
+    if(NOT qtcolorwidgets_POPULATED)
+      FetchContent_Populate(qtColorWidgets)
+      add_subdirectory(${qtcolorwidgets_SOURCE_DIR} ${qtcolorwidgets_BINARY_DIR} EXCLUDE_FROM_ALL)
+    endif()
+  else()
+    FetchContent_MakeAvailable(qtColorWidgets)
+  endif()
+endif()
+
 # This can be read from ${PROJECT_NAME} after project() is called
-if (APPLE)
+if(APPLE)
   set(CMAKE_OSX_DEPLOYMENT_TARGET "10.15" CACHE STRING "Minimum OS X deployment version")
 endif()
 
@@ -53,26 +63,35 @@
   add_definitions(-DFLAMESHOT_VERSION_BUILD=1)
   add_definitions(-DFLAMESHOT_VERSION_STRING="${PROJECT_VERSION}")
 elseif(APPLE)
-  set(Qt5_DIR "$(brew --prefix qt5)/lib/cmake/Qt5/" CACHE PATH "directory where Qt5Config.cmake exists.")
-  set(CMAKE_MACOSX_BUNDLE ON)
-  set(CMAKE_MACOSX_RPATH ON)
+  set(Qt6_DIR "$(brew --prefix qt6)/lib/cmake/Qt6/" CACHE PATH "directory where Qt6Config.cmake exists.")
 endif()
 set(RUN_IN_PLACE
-        ${DEFAULT_RUN_IN_PLACE}
-        CACHE BOOL "Run directly in source directory structure")
+  ${DEFAULT_RUN_IN_PLACE}
+  CACHE BOOL "Run directly in source directory structure")
 
 
 option(FLAMESHOT_DEBUG_CAPTURE "Enable mode to make debugging easier" OFF)
 option(USE_MONOCHROME_ICON "Build using monochrome icon as default" OFF)
 option(GENERATE_TS "Regenerate translation source files" OFF)
-option(USE_EXTERNAL_SINGLEAPPLICATION "Use external QtSingleApplication library" OFF)
+option(USE_KDSINGLEAPPLICATION "Use KDSingleApplication library" ON)
+option(USE_BUNDLED_KDSINGLEAPPLICATION "Use a bundled version of the KDSingleApplication library" ${USE_KDSINGLEAPPLICATION})
 option(USE_LAUNCHER_ABSOLUTE_PATH "Use absolute path for the desktop launcher" ON)
 option(USE_WAYLAND_CLIPBOARD "USE KF Gui Wayland Clipboard" OFF)
+option(DISABLE_UPDATE_CHECKER "Disable check for updates" OFF)
+option(ENABLE_IMGUR "Enable Imgur Uploader" OFF)
+
+if(ENABLE_IMGUR)
+  add_compile_definitions(ENABLE_IMGUR)
+endif()
+
+if(DISABLE_UPDATE_CHECKER)
+  add_compile_definitions(DISABLE_UPDATE_CHECKER)
+endif()
 
 include(cmake/StandardProjectSettings.cmake)
 
 add_library(project_options INTERFACE)
-target_compile_features(project_options INTERFACE cxx_std_17)
+target_compile_features(project_options INTERFACE cxx_std_20)
 
 add_library(project_warnings INTERFACE)
 
@@ -89,30 +108,39 @@
 
 # allow for static analysis options include(cmake/StaticAnalyzers.cmake)
 
-set(QAPPLICATION_CLASS
-        QApplication
-        CACHE STRING "Inheritance class for SingleApplication")
-
-if(USE_EXTERNAL_SINGLEAPPLICATION)
-  # look for external QtSingleApplication
-  # package dev-qt/qtsingleapplication provides no symlink to current version
-  set(qtsingleapplication_libs libQt5Solutions_SingleApplication-2.6 Qt5Solutions_SingleApplication-2.6)
-  find_library(QTSINGLEAPPLICATION_LIBRARY NAMES ${qtsingleapplication_libs})
-  message(STATUS "Using external SingleApplication library")
-else()
-  add_subdirectory(external/singleapplication)
-  set(QTSINGLEAPPLICATION_LIBRARY SingleApplication::SingleApplication)
-endif()
-
-
+if(USE_KDSINGLEAPPLICATION)
+  if(USE_BUNDLED_KDSINGLEAPPLICATION)
+    set(KDSingleApplication_EXAMPLES OFF CACHE BOOL "Don't build the examples")
+    set(KDSingleApplication_STATIC ON CACHE BOOL "Build static versions of the libraries")
+
+    # Check if KDSingleApplication is available locally
+    if(EXISTS "${CMAKE_SOURCE_DIR}/external/KDSingleApplication/CMakeLists.txt")
+      add_subdirectory("${CMAKE_SOURCE_DIR}/external/KDSingleApplication")
+    else()
+      FetchContent_Declare(
+        kdsingleApplication
+        GIT_REPOSITORY https://github.com/KDAB/KDSingleApplication.git
+        GIT_TAG v1.2.0
+      )
+      FetchContent_MakeAvailable(kdsingleApplication)
+    endif()
+  else()
+    find_package(KDSingleApplication-qt6 REQUIRED)
+  endif()
+endif()
+
+# ToDo: Check if this is used anywhere
 option(BUILD_STATIC_LIBS ON)
-option(BUILD_SHARED_LIBS OFF)
-add_subdirectory(external/Qt-Color-Widgets EXCLUDE_FROM_ALL) 
-
-
-if (APPLE)
-  add_subdirectory(external/QHotkey)
-endif()
+
+if(APPLE)
+  FetchContent_Declare(
+    qHotKey
+    GIT_REPOSITORY https://github.com/flameshot-org/QHotkey
+    GIT_TAG master
+  )
+  FetchContent_MakeAvailable(QHotKey)
+endif()
+
 add_subdirectory(src)
 
 # CPack

=== debian/changelog ===
flameshot (13.3.0+git20251204-1~mx25+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 07 Dec 2025 20:22:18 -0800

flameshot (13.3.0+git20251204-1) unstable; urgency=medium

  * QA upload.
  * New upstream snapshot 13.3.0+git20251204.
    + Likely solved the image clipboard issue. (Closes: #1121920)

 -- Boyuan Yang <byang@debian.org>  Fri, 05 Dec 2025 14:56:14 -0500

flameshot (13.3.0-2) unstable; urgency=medium

  * QA upload.
  * debian/control: Depends on qt6-svg-plugins instead of libqt6svg6
    in hope that the SVG support could be recovered in #1121703.

 -- Boyuan Yang <byang@debian.org>  Thu, 04 Dec 2025 10:52:47 -0500

=== debian/control ===
--- 
+++ 
@@ -20,7 +20,10 @@
 
 Package: flameshot
 Architecture: any
-Depends: hicolor-icon-theme, libqt6svg6, ${misc:Depends}, ${shlibs:Depends}
+Depends: hicolor-icon-theme,
+         qt6-svg-plugins,
+         ${misc:Depends},
+         ${shlibs:Depends}
 Recommends: grim,
             xdg-desktop-portal-gtk | xdg-desktop-portal-gnome | xdg-desktop-portal-kde | xdg-desktop-portal-wlr
 Suggests: ca-certificates, openssl, qt6-image-formats-plugins
